<?
/*
   KISGB - a Guest Book script written in PHP.
   Copyright (C) 2001 Gaylen Fraley
   gfraley5@earthlink.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
session_start();
require("config.php");
require("$path_to_languages/$language");
require("classes.php");
require("filters.inc.php");
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; $charset\"/>";
reset ($HTTP_POST_VARS);
while (list ($key, $val) = each ($HTTP_POST_VARS)) {
	for ($i=0;$i<count($badwords);$i++) { 
		if (strpos($val,"$badwords[$i]")===false) {}
		else {
			?>
			<table align=center border=2 width="50%" bgcolor=lightyellow>
			<tr><td align=center><?=$bad_language_msg?><br><font color=red><b><?="$key = $val"?></b></font>
			<br>
			<br>
			<a href="javascript:history.go(-1)"><?=$label_back?></a>
			</td></tr>
			</table>
			<?
			exit;
		} 
	}
}
reset ($HTTP_POST_VARS);
$write_header = 0;
if (!file_exists("$path_to_gb")) {
	$write_header = 1;
	$header = "";
	for ($i=1;$i<16;$i++) {
		if ($i==1) $comma = "";
		else $comma = ",";
		$header .= $comma.${"col$i"};
	}
	$header .= "\n";
}

$fp = fopen("$path_to_gb","r") or die("$unable_to_access_file_msg $path_to_db");
flock($fp,1);
while ($data = fgetcsv($fp,4096,",")) {
$msgid = $data[0];
}
flock($fp,3);
if (!is_numeric($msgid)) $msgid = 0;
$msgid++;
$ip = getenv(REMOTE_ADDR);
$date = date($date_format);
$time = date($time_format);
$fp = fopen("$path_to_gb","a") or die("$unable_to_access_file_msg $path_to_db");
flock($fp,1);
if ($write_header) fwrite($fp,$header);
fwrite($fp,"$msgid");
fwrite($fp,",$ip");
fwrite($fp,",$date");
fwrite($fp,",$time");
reset ($HTTP_POST_VARS);
while (list ($key, $val) = each ($HTTP_POST_VARS)) {
	if (chop($key)=="PHPSESSID") continue;
	$val = htmlspecialchars($val,ENT_QUOTES);
	$val = str_replace("http://", "", $val);
	if ($key=="comments") {
		$rep_str = "";
		for ($i=0;$i<$allow_carriage_returns_max;$i++) {
			$rep_str .= '\\1';
		}
		$val = preg_replace("/(\n|<br>|\r\n){".$allow_carriage_returns_max.",}/i", "$rep_str", $val);
		$val = substr($val,0,$max_comment_length);
		fwrite($fp,",\"$val\"");
	}
	else fwrite($fp,",$val");
}
fwrite($fp,"\n");
flock($fp,3);
fclose($fp);
?>
<html>
<head>
	<style>
		BODY {
			<? if ($body_background_image > "") {
				echo 'background-image : url('.$body_background_image.');';
			}
			 else if ($body_background_color > "") {
				echo 'background-color : '.$body_background_color.';';
			}
			?>
		}
		TD	{
			color: <?echo $Awindow_text_color; ?>;
			vertical-align : top;
			background-color : <?echo $Awindow_background_color; ?>;
			text-align:center;
		}	
		TH {
			background-color : <?echo $Awindow_title_background_color; ?>;
			color : <?echo $Awindow_title_text_color; ?>;		
		}
	</style>
</head>
<body>
	<table width="25%" align=center valign=center border=3 rules=none cellspacing=0 cellpadding=1>
	<tr><td><?=chop($label_successful);?> 
	<tr><td align=center><a href="index.php?action=view"><?=$label_back?></a>
	</table>
</form>
</body>
</html>
<?
if ($admin_email_advice && $admin_email_address > '') {
	require("config.php");	
	$to = $admin_email_address;
	if ("$admin_email_address"!="") $to .= ",$admin_email_address_addl";
	$subject = $admin_email_subject;
	$msg = $admin_email_msg;
	reset ($HTTP_POST_VARS);
	while (list ($key, $val) = each ($HTTP_POST_VARS)) {
		$msg .= "$key : $val\n";
	}
	if ($admin_email_show_server_vars) {
		reset ($HTTP_SERVER_VARS);	
		$msg .= "\n";
		while (list ($key, $val) = each ($HTTP_SERVER_VARS)) {
			$msg .= "$key : $val\n";
		}
	}

	@mail($to, $subject, "$msg","From: $admin_email_address") ;
}
if ($guest_email_advice && $HTTP_POST_VARS['email'] > ' ') {
	$to = $HTTP_POST_VARS['email'];
	$subject = $guest_email_subject;
	$msg = $guest_email_msg;
	@mail($to, $subject, "$msg","From: $admin_email_address") ;
}
?>