<html>
<head>
<style>
	body {background-color:wheat;}
	td {text-align:center;}
	.center {text-align:center;}
	.left {text-align:left;}
	.blue {color:blue;}
	#file_locate_error {background-color:pink;color:red;font-weight:bold;<font-size:14pt;}
	td.intro {font-size:12pt;color:blue;text-align:center}
</style>
</head>
<body VLINK="blue" LINK="blue" ALINK="blue">
<h1 class=center>KISGB Install Script</h1>
<?
if ($submit=="Exit") {
	echo "<html><body><form method=post><table border=1 width=\"75%\" align=center><tr><td id=\"file_locate_error\" align=center><h1>Install canceled by user.</h1></td></tr></table></form>";
;
	unset($submit);
	exit;
}
$default_install_path = dirname(dirname($PATH_TRANSLATED));
require("$default_install_path/functions.php");
check_php_version();
$default_path_for_kisgb = "$default_install_path/kisgb.csv.php";
$default_path_for_docs = "$default_install_path/docs";
$default_path_for_images = "$default_install_path/images";
$default_path_for_smilies = "$default_path_for_images/smilies";
$default_path_for_config = "$default_install_path/config.php";
$default_path_for_orig_config = "$default_install_path/config-dist.php";
$default_path_for_themes = "$default_install_path/themes";
$default_path_for_languages = "$default_install_path/languages";
$host_name_ip = gethostbyname($SERVER_NAME);
function err_msg ($err_num,$file,$path) {
	global $PHP_SELF;
	if ($err_num==1)
	return "<hr width=\"75%\"><form method=post><table border=1 width=\"75%\" align=center><tr><td id=\"file_locate_error\">ERROR!<br>Unable to locate the $file file.<br>Please verify that $file is in the $path directory and resubmit.</td></tr></table></form>";
	else if ($err_num==2)
	return "<hr width=\"75%\"><form method=post action=\"$PHP_SELF\"><table border=1 width=\"75%\" align=center><tr><td id=\"file_locate_error\">Warning!<br>The setup program has found an existing copy of the KISGB! This setup program cannot continue. Since previous installs may not be valid for this release, you should remove your existing copy from the default directory and restart. After the setup program completes, you can compare the structure of the old and new $file. If they are compatable, then replace the new one with the old one.<br><br>Alternatively, this install program can either rename your old $file to $file.orig and then create a new $file or, if you know that there are no changes to the $file structure, you can have it skip the $file creation step. What do you want to do?<br><br><input type=submit name=submit value=Rename>&nbsp;&nbsp;<input type=submit name=submit value=Skip>&nbsp;&nbsp;<input type=submit name=submit value=Exit></td></tr></table></form>";
}
#########################################################################################
# Process error in location of needed files.                                            #
#########################################################################################
if (!$submit=="Skip") {
	if (file_exists($default_path_for_kisgb)) {
	echo err_msg(2,"kisgb.csv.php","$default_install_path");
	exit;
	}
}
if (!file_exists($default_path_for_config)) {
echo err_msg(1,"config.php","$default_install_path");
exit;
}
if (!file_exists($default_path_for_orig_config)) {
echo err_msg(1,"config-dist.php","$default_install_path");
exit;
}
if (!file_exists($default_path_for_languages)) {
echo err_msg(1,"languages","$default_install_path");
exit;
}
if (!file_exists($default_path_for_themes)) {
echo err_msg(1,"themes","$default_install_path");
exit;
}
if (!file_exists($default_path_for_docs)) {
echo err_msg(1,"docs","$default_install_path");
exit;
}
if (!file_exists($default_path_for_images)) {
echo err_msg(1,"images","$default_install_path");
exit;
}
if (!file_exists($default_path_for_smilies)) {
echo err_msg(1,"smilies","$default_install_path");
exit;
}
#########################################################################################

require($default_path_for_config);

#########################################################################################
# If this is the initial entry into script, give an intro and verify that the installer #
# wants to continue.                                                                    #
#########################################################################################
if (!isset($submit)||$submit=="Skip"||$submit=="Rename") {
	if ($submit=="Rename") {
		@rename($default_path_for_kisgb,$default_path_for_kisgb.".original") or die("Unable to rename $default_path_for_kisgb. To proceed with the install, rename the file manually and then rerun.");
	}
?>
<form method=post name=continue action="<?=$PHP_SELF?>">
<center>
<?if ($submit=="Skip") echo "<input type=hidden name=skip value=1>";
  else echo "<input type=hidden name=skip value=0>";?>
<table border=1 width="75%" align=center>
<tr><td class=intro>This install script will set up your basic configuration file <? if ($submit!="Skip") echo "and initialize the kisgb.csv.php file";?>.<br><br>Do you wish to continue with this automated script?<br><br><input type=submit name=submit value="Continue?">
</td></tr>
</table>
</center>
</form>
<?
}
#########################################################################################

#########################################################################################
# Collect information to update the config file.                                        #                           #########################################################################################
else if ($submit=="Continue?") {
require("../config.php");
$handle=opendir($default_path_for_languages);
$lang_sb = "";
$cnt = 0;
while (($file = readdir($handle))!==false) {
	if ($file == '.'||$file == '..') continue;
	$lang = explode('.',$file);
	if (chop($lang[1]) != "lang") continue;	
	$cnt++;
	if ($cnt==1) {
		$lang_sb = "<select name=language >\n";}
	$selected = "";
	$lang_sb .= "<option value=\"$file\">$lang[0]</option>\n";
}
if ($cnt>0) $lang_sb .= "</select>\n";
closedir($handle);

$handle=opendir($default_path_for_themes);
$theme_sb = "";
$cnt = 0;
while (($file = readdir($handle))!==false) {
	if ($file == '.'||$file == '..') continue;
	$thm = explode('.',$file);
	if (chop($thm[1]) != "thm") continue;
	$cnt++;
	if ($cnt==1) {
		$theme_sb = "<select name=theme>\n";}
	$theme_sb .= "<option value=\"$file\">$thm[0]</option>\n";
}
if ($cnt>0) $theme_sb .= "</select>\n";
closedir($handle);
	
?>
<script>
function pwMatch() {
	if (document.forms[0].admin_id.value.length==0) {
		alert('ERROR!\nYou must supply an Administrator name/id.\nPlease re-enter.');
		document.forms[0].admin_id.focus();
		return false;
	}
	if (document.forms[0].admin_pw.value != document.forms[0].admin_pw_v.value || document.forms[0].admin_pw.value.length==0) {
		alert('ERROR!\nPasswords do not match or are blank.\nPlease re-enter.');
		document.forms[0].admin_pw.focus();
		return false;
	}

	if (document.forms[0].secure_site[1].checked) return true;
	if (document.forms[0].secure_site_id.value.length==0) {
		alert('ERROR!\nYou must supply an Secure Site name/id.\nPlease re-enter.');
		document.forms[0].secure_site_id.focus();
		return false;
	}
	if (document.forms[0].secure_site_pw.value != document.forms[0].secure_site_pw_v.value || document.forms[0].secure_site_pw.value.length==0) {
		alert('ERROR!\nPasswords do not match or are blank.\nPlease re-enter.');
		document.forms[0].secure_site_pw.focus();
		return false;
	}
	return true;
}
</script>
<form name=continue action="<?=$PHP_SELF?>" onSubmit="return(pwMatch())" method=post>
<?if (isset($skip))
	echo "<input type=hidden name=skip value=$skip>";
	else echo "<input type=hidden name=skip value=0>";
?>
<table border=1 width="75%" align=center>
<tr><td class=intro colspan=2>Please fill in the following sections and then press Update to process your selections.<br>For help, click on the underlined option that you need help on.</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q1" target=_explain>Default Language</a></td><td><?=$lang_sb?></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q2" target=_explain>Default Theme</a></td><td><?=$theme_sb?></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q3" target=_explain>Administrator ID</a></td><td><input name=admin_id></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q4" target=_explain>Administrator Password</a></td><td><input type=password name=admin_pw></td></tr>
<tr><td class=blue>Re-enter Administrator Password</td><td><input type=password name=admin_pw_v onBlur="pwMatch()"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q15" target=_explain>Is this a Private Guest Book that requires user/password protection for entry or is it to be open to the Public?</a></td><td><input type=radio name=secure_site value=true>Private&nbsp;&nbsp;<input type=radio name=secure_site value=false checked>Public</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q16" target=_explain>Secure Site User ID</a></td><td><input name=secure_site_id></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q17" target=_explain>Secure Site  Password</a></td><td><input type=password name=secure_site_pw></td></tr>
<tr><td class=blue>Re-enter Secure Site Password</td><td><input type=password name=secure_site_pw_v onBlur="pwMatch()"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q5" target=_explain>Allow Administration from the Web?</a></td><td><input type=radio name=admin_from_web value=true checked>True&nbsp;&nbsp;<input type=radio name=admin_from_web value=false>False</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q6" target=_explain>Administrator IP Addresses (separate with commas), or use an asterisk for all addresses.</a></td><td><input name=myIP size=40 value=<?=$HTTP_SERVER_VARS["SERVER_ADDR"].",".$host_name_ip?>></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q7" target=_explain>If allowing administration from the web, do you want to limit it to only the addresses mentioned above?</a></td><td><input type=radio name=lock_admin_to_myIP value=true>True&nbsp;&nbsp;<input type=radio name=lock_admin_to_myIP value=false checked>False</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q8" target=_explain>This site's URL</a></td><td><input name=site_url value="http://<?=$HTTP_SERVER_VARS["SERVER_NAME"]?>" size=40></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q9" target=_explain>Guest Book name.  This will be used in signatures and in the Web Browser Title Bar.</a></td><td><input name=guestbook_name value="KISGB" size=40></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q10" target=_explain>Administrator E-Mail Address</a></td><td><input name=admin_email_address size=40 value="<?=$HTTP_SERVER_VARS["SERVER_ADMIN"]?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q11" target=_explain>Additional E-Mail Addresses for notification (separate multiple addresses with commas)</a></td><td><input name=admin_email_address_addl size=40></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q12" target=_explain>Send email advice to Admin when an entry is added into the guest book?</a></td><td><input type=radio name=admin_email_advice value=true checked>True&nbsp;&nbsp;<input type=radio name=admin_email_advice value=false>False</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q13" target=_explain>Send email advice to Guest when an entry is added into the guest book?</a></td><td><input type=radio name=guest_email_advice value=true checked>True&nbsp;&nbsp;<input type=radio name=guest_email_advice value=false>False</td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col1?>"</a></td><td><input name=col1 size=10 value="<?=$col1?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col2?>"</a></td><td><input name=col2 size=10 value="<?=$col2?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col3?>"</a></td><td><input name=col3 size=10 value="<?=$col3?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col4?>"</a></td><td><input name=col4 size=10 value="<?=$col4?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col5?>"</a></td><td><input name=col5 size=10 value="<?=$col5?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col6?>"</a></td><td><input name=col6 size=10 value="<?=$col6?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col7?>"</a></td><td><input name=col7 size=10 value="<?=$col7?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col8?>"</a></td><td><input name=col8 size=10 value="<?=$col8?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col9?>"</a></td><td><input name=col9 size=10 value="<?=$col9?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col10?>"</a></td><td><input name=col10 size=10 value="<?=$col10?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col11?>"</a></td><td><input name=col11 size=10 value="<?=$col11?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col12?>"</a></td><td><input name=col12 size=10 value="<?=$col12?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col13?>"</a></td><td><input name=col13 size=10 value="<?=$col13?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col14?>"</a></td><td><input name=col14 size=10 value="<?=$col14?>"></td></tr>
<tr><td class=blue><a href="../docs/config.explain.html#q14" target=_explain>Guest Book file column heading for  "<?=$col15?>"</a></td><td><input name=col15 size=10 value="<?=$col15?>"></td></tr>
<tr><td colspan=2><input type=submit name=submit value="Update"></td></tr>
</table>
</form>
<?
}
#########################################################################################

#########################################################################################
# Update
#                  .                                                                    #
#########################################################################################
else if ($submit=="Update") {
	$config = file($default_path_for_orig_config);
	$build_file = "";
	while (list ($line_num, $line) = each ($config)) {
		reset ($HTTP_POST_VARS);
		while (list ($key, $val) = each ($HTTP_POST_VARS)) {
			$found=false;
			$line_array = explode('=',$line);
			if (chop($line_array[0])=='$'.$key) {
				if (is_numeric(chop($val)));
				else if ("$val"=="true"||"$val"=="false");
				else $val = "\"$val\"";
				$found = true;
			}
			if ($found) break;
		}

	/* Strip off 0Dx and 0Ax that are retained with file() call */
	/* Then add back 0Dx */
		if (!$found) $build_file .= substr($line,0,strlen($line)-2)."\n";
		else $build_file .= '$'.$key." = ".$val.";\n";
	}
	$open_config = @fopen($default_path_for_config,'w') or die("$unable_to_access_file_msg $default_path_for_config.");
	$write_config = @fwrite($open_config,$build_file) or die("$unable_to_access_file_msg $default_path_for_config.");
	fclose($open_config);

	if (!$skip) {
		if (!file_exists("$path_to_gb")) {
			$write_header = 1;
			$header = "";
			for ($i=1;$i<16;$i++) {
				if ($i==1) $comma = "";
				else $comma = ",";
				$header .= $comma.$HTTP_POST_VARS["col$i"];
			}
			$header .= "\n";
			$fp = fopen("../$path_to_gb","a") or die("$unable_to_access_file_msg $path_to_db");
			flock($fp,1);
			if ($write_header) fwrite($fp,$header);
			flock($fp,3);
			fclose($fp);
		}
	}

?>
<form action="../../" method=post>
<center>
<table border=1 width="75%" align=center>
<tr><td class=intro>The config.php file has been updated <? if (!$skip) echo "and the guestbook initialized"?>.<br><br> Please review for accuracy.<br><br><input type=submit value="Run KISGB"> 
</td></tr>
</table>
</center>
</form>
<?
}
#########################################################################################
?>
</body>
</html>