<?php
/*
   KISGB - a Guest Book script written in PHP.
   Copyright (C) 2001 Gaylen Fraley
   gfraley5@earthlink.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
session_start();
session_register("valid_user");
require("config.php");
if (session_is_registered('temp_language')) $language = $temp_language;
if (session_is_registered('temp_theme')) $theme = $temp_theme;
require("$path_to_themes/$theme");
require("$path_to_languages/$language");
require("filters.inc.php");
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; $charset\"/>";
?>
<html>
<head>
	<style>
		BODY {
			<? if ($body_background_image > "") {
				echo 'background-image : url('.$body_background_image.');';
			}
			 else if ($body_background_color == "color") {
				echo 'background-color : '.$body_background_color.';';
			}
			?>
		}
		TD	{
			color: <?= $Awindow_text_color; ?>;
			vertical-align : middle;
			background-color : <?= $Awindow_background_color; ?>;
			text-align:center;
		}	
		TH {
			background-color : <?= $Awindow_title_background_color; ?>;
			color : <?= $Awindow_title_text_color; ?>;		
		}
	</style>
	<script>
		function validate() {
			return true;
		}
	</script>
</head>
<body>
<?
if ($lock_admin_to_myIP && $myIP != $HTTP_SERVER_VARS["REMOTE_ADDR"]) {
	echo "<table border=1 align=center><tr><td>$not_authorized_msg</table><p><center><a href='javascript:history.go(-1)'>$label_back</a></center>";
	include_once 'footer.php';
	exit;
}

if (isset($action) && $action == 'admin') {
	if (("$user" == "$admin_id" && "$password" == "$admin_pw")||$valid_user==$admin_id) {
		$valid_user = $admin_id;
		echo "<p><center><a href='index.php?action=view'>".$label_back."</a></center>";
		echo "<p><center><a href='upconfig.php'>$label_update $label_config</a></center>";
		Require("footer.php");
?>
	<style>
		BODY {
			<? if ($body_background_image > "") {
				echo 'background-image : url('.$body_background_image.');';
			}
			 else if ($body_background_color > "") {
				echo 'background-color : '.$body_background_color.';';
			}
			?>
		}
		TD	{
			vertical-align : top;
			text-align:left;
		}
		TD#td1	{
			color: <?echo $Vwindow_text_color1; ?>;
			background-color : <?echo $Vwindow_background_color1; ?>;
		}
		TD#td2	{
			color: <?echo $Vwindow_text_color2; ?>;
			background-color : <?echo $Vwindow_background_color2; ?>;
		}
		TH {
			background-color : <?echo $Vwindow_title_background_color; ?>;
			color : <?echo $Vwindow_title_text_color; ?>;		
		}
		TABLE {
			height:<?echo $Vtable_height; ?>;
			width:<?echo $Vtable_width; ?>;
		}
	</style>
<?
	$row = 0;
	$tmp_data = array();
	$fp = fopen("$path_to_gb","r") or die("$unable_to_access_file_msg $path_to_db");
	flock($fp,1);
	for ($i=0;$i<15;$i++) {
		$j = $i+1;
		$head_array[$i] = ${"col$j"};
	}
	$rn = 0;
	$entries = 0;
	while ($data = fgetcsv($fp,4096,",")) {
		$row++;
		if ($row>1) {
			$rn++;
			$num = count($data);
			$entries++;
			for ($c=0;$c<$num;$c++) {
				$tmp_data[$rn][$c] = $data[$c];
			}
		}
	}
	flock($fp,3);
	fclose($fp);
	$data = array();  #release memory;
	$rows = $row;	
	echo "<table align=center style=\"height:1%\" cellpadding=$Vwindow_cellpadding cellspacing=$Vwindow_cellspacing border=$Vwindow_border rules=none>";
	echo "<tr><td style=\"text-align:left;background-color:$Vwindow_title_background_color;color:$Vwindow_title_text_color;\">$entries $label_entries_public</td><td style=\"text-align:right;background-color:$Vwindow_title_background_color;color:$Vwindow_title_text_color;\">$Vwindow_title</td>";
	echo "</table>";
	for ($c=$rn;$c>0;$c--) {
	    echo "<form action=\"updategb.php\" method=post>";
		echo "<table align=center rules=none cellpadding=$Vwindow_cellpadding cellspacing=$Vwindow_cellspacing border=$Vwindow_border>";
		if ($rn%2) $id="td1"; else $id = "td2";
		$id = "td1";
		echo "<tr><td id=\"$id\"><font size=2>".$head_array[4].":&nbsp;<input name=\"$head_array[4]\" value=\"".$tmp_data[$rn][4]."\">";
		echo "<td id=\"$id\">".$head_array[12].":&nbsp;<input name=\"$head_array[12]\" value=".$tmp_data[$rn][12].">";
		echo "<td id=\"$id\">".$head_array[5].":&nbsp;<input name=\"$head_array[5]\" value=".$tmp_data[$rn][5].">";
		echo "<td id=\"$id\">".$head_array[6].":&nbsp;<input name=\"$head_array[6]\" value=".$tmp_data[$rn][6].">";
		echo "<tr><td id=\"$id\">".$head_array[7].":&nbsp;<input name=\"$head_array[7]\" value=".$tmp_data[$rn][7].">";
		echo "<td id=\"$id\">".$head_array[8].":&nbsp;<input name=\"$head_array[8]\" value=".$tmp_data[$rn][8].">";
		echo "<td id=\"$id\">".$head_array[9].":&nbsp;<input name=\"$head_array[9]\" value=".$tmp_data[$rn][9].">";
		echo "<td id=\"$id\">".$head_array[10].":&nbsp;<input name=\"$head_array[10]\" value=".$tmp_data[$rn][10].">";
		echo "<tr><td id=\"$id\">".$head_array[11].":&nbsp;<input name=\"$head_array[11]\" value=".$tmp_data[$rn][11].">";
		echo "<td id=\"$id\">".$head_array[1].":&nbsp;<input name=\"$head_array[1]\" value=".$tmp_data[$rn][1].">";
		echo "<td id=\"$id\">".$head_array[2].":&nbsp;<input name=\"$head_array[2]\" value=".$tmp_data[$rn][2].">";
		echo "<td id=\"$id\">".$head_array[3].":&nbsp;<input name=\"$head_array[3]\" value=".$tmp_data[$rn][3].">";
		echo "<tr><td  id=\"$id\" colspan=4>".$head_array[14].":&nbsp;<input name=\"$head_array[14]\" size=5 value=".$tmp_data[$rn][14].">";
		$tmp_data[$rn][13] = stripslashes($tmp_data[$rn][13]);

		if ($tmp_data[$rn][14]=="on") $style = "style=\"background-color:$admin_private_message_color;\"";
		else $style = "";
		echo "<tr><td  id=\"$id\" colspan=4>".$head_array[13].":&nbsp;<textarea name=\"$head_array[13]\" rows=5 cols=80 $style>".$tmp_data[$rn][13]."</textarea>";
		echo "<tr><td><input type=submit value=$label_update name=update><td colspan=3><input type=submit value=$label_delete name=delete>";
		echo "</table></center>";
		echo "<input type=hidden name=msgid value=".$tmp_data[$rn][0].">";
		$rn--;
	    echo "</form>";
	}
	$tmp_data = array(); # release memory;

	exit;
}
	else {
		echo "<table align=center border=1 align=center><tr><td>$not_authorized_msg</table><p><center><a href='javascript:history.go(-1)'>$label_back</a></center>";
		include_once 'footer.php';
		exit;	}
}
else {
?>
	<form action="<?="$PHP_SELF?action=admin" ?>" method=post onSubmit="return validate()">
		<table align=center valign=center border=3 rules=none cellspacing=0 cellpadding=5>
		<tr>
		<tr><td><?=$label_name?><td><input name=user>
		<tr><td><?=$label_password?><td><Input type=password name=password>
		<tr><td align=center colspan=2><input type=submit value=<?="$label_login"?> name="submit">&nbsp;&nbsp;<input type=button value=<?="$label_back"?> onClick="history.go(-1)">
		</table>
	</form>
	</body>
	</html>
<?
}
require("footer.php");
?>
<script>
	document.forms[0].user.focus();
</script>