<?
/*
   KISGB - a Guest Book script written in PHP.
   Copyright (C) 2001 Gaylen Fraley
   gfraley5@earthlink.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
session_start();
require("config.php");
if (session_is_registered('temp_language')) $language = $temp_language;
if (session_is_registered('temp_theme')) $theme = $temp_theme;
require("$path_to_themes/$theme");
require("$path_to_languages/$language");
require("filters.inc.php");
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; $charset\"/>";
?>
<style>
	td	{
		background-color:<?=$Config_table_background_color?>;
	}
</style>
<script>
	var _name_="";
</script>
<?
if (session_is_registered("valid_user") && $valid_user==$admin_id) {
	$config = file("config.php");
	$number_of_lines = count($config);
	$handle=opendir($path_to_languages);
	$lang_sb = "";
	$selected_lang = explode('.',$language);
	$cnt = 0;
	while (($file = readdir($handle))!==false) {
		if ($file == '.'||$file == '..') continue;
		$lang = explode('.',$file);
		if (chop($lang[1]) != "lang") continue;
		$cnt++;
		if ($cnt==1) {
			$lang_sb = "<select name=language>\n";
		}
		$selected = "";
		if ($lang[0] == $selected_lang[0]) $selected = "selected"; 
		$lang_sb .= "<option value=\"$file\" $selected>$lang[0]</option>\n";
	}
	if ($cnt>0) $lang_sb .= "</select>\n";
	closedir($handle);

	$handle=opendir($path_to_themes);
	$theme_sb = "";
	$selected_theme = explode('.',$theme);
	$cnt = 0;
	while (($file = readdir($handle))!==false) {
		if ($file == '.'||$file == '..') continue;
		$theme = explode('.',$file);
		if (chop($theme[1]) != "thm") continue;
		$cnt++;
		if ($cnt==1) {
			$theme_sb = "<select name=theme>\n";
		}
		$selected = "";
		if ($theme[0] == $selected_theme[0]) $selected = "selected"; 
		$theme_sb .= "<option value=\"$file\" $selected>$theme[0]</option>\n";
	}
	if ($cnt>0) $theme_sb .= "</select>\n";
	closedir($handle);

	if (!isset($action) || $action != "update") {
?>
		<html>
		<head>
		<style>
			table {width:<?=$Config_update_table_width?>;}
		</style>
		</head>
		<body>
		<form action="<?="$PHP_SELF?action=update" ?>" method=post>
		<table align=center border=0 rules=none cellspacing=0 cellpadding=0>
		<tr>
		<td align=left>[<a onClick="if (blur) self.blur();" href="<?=$path_to_docs?>/config.explain.html" target=_help><?=$label_help?></a>]</td>
		<td align=center>[<a href="index.php?action=view"><?=$label_view_gb?></a>]</td>
		<td align=right>[<a href="admin.php?action=admin"><?=$label_back?></a>]</td>
		</table>
		<table align=center border=2 rules=none cellspacing=0 cellpadding=0>
		<tr>
		<td align=left>Setting</td>
		<td align=left colspan=3>Value</td>
		</tr>
	<?
		for ($i=0; $i<$number_of_lines; $i++) {
			if (substr($config[$i],0,2) == '<?'||substr($config[$i],0,2) == '?>') continue;
			$t_checked = "";
			$f_checked = "";
			$color_b = "";
			$line = explode("=",str_replace(';','',$config[$i]));
			if (trim($line[1])=='true') $t_checked = 'checked';
			if (trim($line[1])=='false') $f_checked = 'checked';			
			if (substr($line[0],0,1)!="$") $comment=true;
			else $comment=false;
			if ($comment) {
				$tag = "<td style=\"background-color:$Config_table_background_comment_color;\" colspan=3>&nbsp;&nbsp;$line[0]</td>";
			}
			
			else if (trim($line[0])=='$guestbook_signature'||trim($line[0])=='$admin_email_msg'||trim($line[0])=='$guest_email_msg') {
				$_name_ = trim(substr($line[0],1));
				$_line_ = trim($line[1]);
				if (strpos(trim($line[0]),"_color")===false);
				else $color_b="<input type=button value=\"Colors\" onClick=\"_name_='$_name_';open('colorwheel.html','','width=256,height=350');\">";
				$tag = "<td>&nbsp;&nbsp;".substr($line[0],1)."&nbsp;&nbsp;</td><td>$color_b<textarea name=\"$_name_\" rows=4 cols=50 >".substr($_line_,1,strlen($_line_)-2)."</textarea></td><td>&nbsp;<input type=submit value=\"$label_update\" name=\"submit\"></td></tr>";
			}
			
			else if (trim($line[0])=='$language') $tag = "<td>&nbsp;&nbsp;".substr($line[0],1)."&nbsp;&nbsp;</td><td>$lang_sb</td><td>&nbsp;<input type=submit value=\"$label_update\" name=\"submit\"></td></tr>";
			
			else if (trim($line[0])=='$theme') $tag = "<td>&nbsp;&nbsp;".substr($line[0],1)."&nbsp;&nbsp;</td><td>$theme_sb</td><td>&nbsp;<input type=submit value=\"$label_update\" name=\"submit\"></td></tr>";
			
			else if (trim($line[1])=='true'||trim($line[1])=='false') {$tag = "<td>&nbsp;&nbsp;".substr($line[0],1)."&nbsp;&nbsp;</td><td><input type=radio name=\"".trim(substr($line[0],1))."\" $t_checked value=\"true\">true&nbsp;&nbsp;<input type=radio name=\"".trim(substr($line[0],1))."\" $f_checked value=\"false\">false</td><td>&nbsp;<input type=submit value=\"$label_update\" name=\"submit\"></td></tr>";}
			
			else {
				$_name_ = trim(substr($line[0],1)); 
				if (strpos(trim($line[0]),"_color")===false);
				else $color_b="<input type=button value=\"Colors\" onClick=\"_name_='$_name_';open('colorwheel.html','','width=256,height=350');\">";
				$tag = "<td>&nbsp;&nbsp;".substr($line[0],1)."&nbsp;&nbsp;</td><td>$color_b<input name=\"$_name_\" value=$line[1] size=40></td><td>&nbsp;<input type=submit value=\"$label_update\" name=\"submit\"></td></tr>";
			}
	?>
		<tr><?=$tag;?>
	<?
		}
		echo "<tr><td colspan=3>&nbsp;<tr><td align=center colspan=3><input type=submit value=\"$label_update\"></td></tr>";
	?>
		</table>
		</form>
		</body>
		</html>
	<?
	}
	else if ($admin_from_web==true) {
		reset ($HTTP_POST_VARS);
		$path_to_config_BACKUP = "config.bak"."_".date("Ymd")."_".date("His");
		if (!rename('config.php',$path_to_config_BACKUP)) die("$unable_to_access_file_msg $path_to_config_BACKUP");
		$ns=fopen('config.php','w') or die("$unable_to_access_file_msg"." new config file.");
			$row = 0;
		while (list ($key, $val) = each ($HTTP_POST_VARS)) {
			$val = stripslashes($val);
			while (substr($config[$row],0,1)!='$'&&substr($config[$row],0,1)>' ') {
				fwrite($ns,trim($config[$row])."\n");
				$row++;
			}
			for ($i=0; $i<$number_of_lines; $i++) {
				$line = explode("=",$config[$i]);
				$val = $val==$line[1]?$line[1]:$val;
				if ($val=="true"||$val=="false"||$val=="on"||$val=="off"||is_numeric($val)) $quotes='';
				else $quotes='"';
				if (trim(substr($line[0],1))==trim($key)) {fwrite($ns,$line[0]."= $quotes".$val."$quotes;\n"); $row++;break;}
			}
		}
		fwrite($ns,"?>\n");
		fclose($ns);
		session_unregister('temp_language');
		session_unregister('temp_theme');
		?>
		<html>
		<table border=1 align=center><tr><td><?=$submit?>&nbsp;<?=$label_successful?></table>
		<p><center><a href="<?="$PHP_SELF" ?>"><?=$label_back?></a></center>
		<? require("footer.php"); ?>
		</html>	
		<?
	}
	else {
		echo "<table border=1 align=center><tr><td>DEMO - $label_successful</table><p><center><a href='javascript:history.go(-1)'>$label_back</a></center>";
		require("footer.php");
		exit;
	}

}
else {
	echo "<table border=1 align=center><tr><td>$not_authorized_msg</table><p><center><a href='javascript:history.go(-1)'>$label_back</a></center>";
	require("footer.php");
	exit;
}
?>
